/*
 *  Eksempel paa en GUI-frame, der kan startes baade som applet og som applikation
 *
 *  (Naar den startes som en applikation (java GUIapl), saa kan den kun afbrydes
 *  ved Ctrl-C i Dos-boksen.)
 *
 */

import java.awt.* ;       // brug alle klasser i pakken java.awt

public class GUIapl extends java.applet.Applet {

	GUIfrm appfrm = new GUIfrm ();

	public void init() {
			// Init-rutine i appletversion

                appfrm.setSize (400, 400) ;    // Saet rammens stoerrelse
                appfrm.setVisible (true);      // og "taend" for den
	}

	public static void main (String args[]) {
			// Static-rutine - kan KUN indeholde static variable
			// Derfor m man gemme GUIfrm i en srlig variabel

		GUIfrm aplfrm = new GUIfrm (); // opret nyt objekt
                aplfrm.setSize (400, 400) ;    // Saet rammens stoerrelse
                aplfrm.setVisible (true);      // og "taend" for den
	}
	/*
	 * Eventmetode, der overskrives for at kunne lukke en
	 * ramme ned - i det her tilflde vores GUIfrm
	 */
	public boolean windowsEvent(Event e) {
		// vi ved ikke, hvilken ramme det er - aplform eller
		// appform - men det er ligemeget, for der er en 
		// reference i Event-klassen
		// WINDOWS_CLOSING...
	}
}

/*
 * GUIfrm er en lokal klasse, der udvider frame. Indholdet svarer til GUIapp2.java
 *
 */

class GUIfrm extends Frame {
	/* variable */
	Label etiket1 = new Label("Tekst til venstre",Label.LEFT); 
	Label etiket2 = new Label("Tekst i midten",Label.CENTER);
	Label etiket3 = new Label("Tekst til hoejre",Label.RIGHT);
        // 3 Label-objekter dannes og gemmes i lokale variable

 	Button knap1  = new Button("<< skift"); 
 	Button knap2  = new Button("skift >>");
        // 2 knap-objekter dannes og gemmes lokalt 

        /* 
         * Dannelsen sker samtidig med, at klassen realiseres 
         */



	GUIfrm() {
			// Dette var init() metoden i den originale applet -
                        // nu er det en konstruktoer
		super();
			// Kald til Frame-klassens konstruktoer

			// Resten er uaendret....
       
        /*
         * Alle objekter af typen Container - som GUIapp-klassen her kan
         * styres af metoden setLayout. Naar vi kalder den her, finder systemet
         * automatisk den rigtige defition i en af superklasserne. Meningen med
         * LayoutManager var at goere de grafiske elementer dynamiske. setLayout()
         * tilknytter en manager (en saerlig klasse) til Containeren. Hvis man ikke
         * angiver en manager (setLayout(null)), kan man selv saette stoerrelser og
         * raekkefoelger - med metoderne setBounds() - stoerrelse - og setLocation() 
         * - position.
         */  
		setLayout(null); // bruger INGEN layoutmanager - saet derfor stoerrelse
                                 // og placering

		etiket1.setSize(200,10);
		etiket1.setLocation(10,40);
		etiket2.setSize(200,10);
		etiket2.setLocation(10,80);
		etiket3.setSize(200,10);
		etiket3.setLocation(10,120);

		knap1.setSize (100,40);
		knap1.setLocation(10,240);
		knap2.setSize (100,40);
		knap2.setLocation(240,240);

		add(etiket1) ;   // tilfoej etiketter til display'et
                add(etiket2) ;
                add(etiket3) ;  

		add(knap1)   ;   // tilfoejer de to knapper
                add(knap2)   ;

        }



	public boolean action(Event e, Object arg) {

			// action() er deprecated - foraeldet. Derfor giver
                        // javac en 'warning'.
  
  		if (e.target == knap1)  {
        		knap1_Aktion(); // en lokal metode, der goer alt arbejdet
        		return true;   // signaler, at vi har "taget" eventet
  		} else if (e.target == knap2)  {
        		knap2_Aktion();
        		return true;
  		}
  		else return false;
	}

        /*
         * De to lokale metoder - de kendes ikke uden for denne klasse
         *
         */
	
	void knap1_Aktion() {
		etiket2.setAlignment(Label.LEFT);
	}

	void knap2_Aktion() {
		etiket2.setAlignment(Label.RIGHT);
	}

}
