/*
 *  Eksempel paa en GUI applet, hvor de grafiske elementer ligger
 *  i selve applettens omraade
 */

import java.awt.* ;       // brug alle klasser i pakken java.awt

public class GUIapp2 extends java.applet.Applet {


	/* variable */
	Label etiket1 = new Label("Tekst til venstre",Label.LEFT); 
	Label etiket2 = new Label("Tekst i midten",Label.CENTER);
	Label etiket3 = new Label("Tekst til hoejre",Label.RIGHT);
        // 3 Label-objekter dannes og gemmes i lokale variable

 	Button knap1  = new Button("<< skift"); 
 	Button knap2  = new Button("skift >>");
        // 2 knap-objekter dannes og gemmes lokalt 

        /* 
         * Dannelsen sker samtidig med, at klassen realiseres 
         */



	public void init() {
		// overskriver en standard-rutine, som runtime-systemet bruger
                // naar et objekt er oprettet. De variable er initialiseret - men
                // ellers sker resten her.
       
        /*
         * Alle objekter af typen Container - som GUIapp-klassen her kan
         * styres af metoden setLayout. Naar vi kalder den her, finder systemet
         * automatisk den rigtige defition i en af superklasserne. Meningen med
         * LayoutManager var at goere de grafiske elementer dynamiske. setLayout()
         * tilknytter en manager (en saerlig klasse) til Containeren. Hvis man ikke
         * angiver en manager (setLayout(null)), kan man selv saette stoerrelser og
         * raekkefoelger - med metoderne setBounds() - stoerrelse - og setLocation() 
         * - position.
         */  
		setLayout(null); // bruger INGEN layoutmanager - saet derfor stoerrelse
                                 // og placering

		etiket1.setSize(200,10);
		etiket1.setLocation(10,40);
		etiket2.setSize(200,10);
		etiket2.setLocation(10,80);
		etiket3.setSize(200,10);
		etiket3.setLocation(10,120);

		knap1.setSize (100,40);
		knap1.setLocation(10,240);
		knap2.setSize (100,40);
		knap2.setLocation(240,240);

		add(etiket1) ;   // tilfoej etiketter til display'et
                add(etiket2) ;
                add(etiket3) ;  

		add(knap1)   ;   // tilfoejer de to knapper
                add(knap2)   ;

        }



	public boolean action(Event e, Object arg) {

			// action() er deprecated - foraeldet. Derfor giver
                        // javac en 'warning'.
  
  		if (e.target == knap1)  {
        		knap1_Aktion(); // en lokal metode, der goer alt arbejdet
        		return true;   // signaler, at vi har "taget" eventet
  		} else if (e.target == knap2)  {
        		knap2_Aktion();
        		return true;
  		}
  		else return false;
	}

        /*
         * De to lokale metoder - de kendes ikke uden for denne klasse
         *
         */
	
	void knap1_Aktion() {
		etiket2.setAlignment(Label.LEFT);
	}

	void knap2_Aktion() {
		etiket2.setAlignment(Label.RIGHT);
	}
}
